from typing import Any

class AABB:
    end: Any = ...
    position: Any = ...
    size: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def encloses(self, AABBwith_) -> bool: ...
    def expand(self, Vector3to_point) -> AABB: ...
    def get_area(self) -> float: ...
    def get_endpoint(self, godot_intidx) -> Vector3: ...
    def get_longest_axis(self) -> Vector3: ...
    def get_longest_axis_index(self) -> int: ...
    def get_longest_axis_size(self) -> float: ...
    def get_shortest_axis(self) -> Vector3: ...
    def get_shortest_axis_index(self) -> int: ...
    def get_shortest_axis_size(self) -> float: ...
    def get_support(self, Vector3dir) -> Vector3: ...
    def grow(self, godot_realby) -> AABB: ...
    def has_no_area(self) -> bool: ...
    def has_no_surface(self) -> bool: ...
    def has_point(self, Vector3point) -> bool: ...
    def intersection(self, AABBwith_) -> AABB: ...
    def intersects(self, AABBwith_) -> bool: ...
    def intersects_plane(self, Planeplane) -> bool: ...
    def intersects_segment(self, Vector3from_, Vector3to) -> bool: ...
    def merge(self, AABBwith_) -> AABB: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Basis:
    x: Any = ...
    y: Any = ...
    z: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def determinant(self) -> float: ...
    def from_axis_angle(self, *args, **kwargs) -> Any: ...
    def from_euler(self, *args, **kwargs) -> Any: ...
    def get_elements(self, Vector3elements) -> None: ...
    def get_euler(self) -> Vector3: ...
    def get_orthogonal_index(self) -> int: ...
    def get_quat(self) -> Quat: ...
    def get_row(self, godot_introw) -> Vector3: ...
    def get_scale(self) -> Vector3: ...
    def inverse(self) -> Basis: ...
    def orthonormalized(self) -> Basis: ...
    def rotated(self, Vector3axis, godot_realphi) -> Basis: ...
    def scaled(self, Vector3scale) -> Basis: ...
    def set_axis_angle_scale(self, Vector3axis, godot_realphi, Vector3scale) -> None: ...
    def set_euler_scale(self, Vector3euler, Vector3scale) -> None: ...
    def set_quat(self, Quatquat) -> None: ...
    def set_quat_scale(self, Quatquat, Vector3scale) -> None: ...
    def set_row(self, godot_introw, Vector3value) -> None: ...
    def slerp(self, Basisb, godot_realt) -> Basis: ...
    def tdotx(self, Vector3with_) -> float: ...
    def tdoty(self, Vector3with_) -> float: ...
    def tdotz(self, Vector3with_) -> float: ...
    def transposed(self) -> Basis: ...
    def xform(self, Vector3v) -> Vector3: ...
    def xform_inv(self, Vector3v) -> Vector3: ...
    def __add__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __rsub__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...
    def __sub__(self, other) -> Any: ...

class Color:
    ALICEBLUE: Any = ...
    ANTIQUEWHITE: Any = ...
    AQUA: Any = ...
    AQUAMARINE: Any = ...
    AZURE: Any = ...
    BEIGE: Any = ...
    BISQUE: Any = ...
    BLACK: Any = ...
    BLANCHEDALMOND: Any = ...
    BLUE: Any = ...
    BLUEVIOLET: Any = ...
    BROWN: Any = ...
    BURLYWOOD: Any = ...
    CADETBLUE: Any = ...
    CHARTREUSE: Any = ...
    CHOCOLATE: Any = ...
    CORAL: Any = ...
    CORNFLOWER: Any = ...
    CORNSILK: Any = ...
    CRIMSON: Any = ...
    CYAN: Any = ...
    DARKBLUE: Any = ...
    DARKCYAN: Any = ...
    DARKGOLDENROD: Any = ...
    DARKGRAY: Any = ...
    DARKGREEN: Any = ...
    DARKKHAKI: Any = ...
    DARKMAGENTA: Any = ...
    DARKOLIVEGREEN: Any = ...
    DARKORANGE: Any = ...
    DARKORCHID: Any = ...
    DARKRED: Any = ...
    DARKSALMON: Any = ...
    DARKSEAGREEN: Any = ...
    DARKSLATEBLUE: Any = ...
    DARKSLATEGRAY: Any = ...
    DARKTURQUOISE: Any = ...
    DARKVIOLET: Any = ...
    DEEPPINK: Any = ...
    DEEPSKYBLUE: Any = ...
    DIMGRAY: Any = ...
    DODGERBLUE: Any = ...
    FIREBRICK: Any = ...
    FLORALWHITE: Any = ...
    FORESTGREEN: Any = ...
    FUCHSIA: Any = ...
    GAINSBORO: Any = ...
    GHOSTWHITE: Any = ...
    GOLD: Any = ...
    GOLDENROD: Any = ...
    GRAY: Any = ...
    GREEN: Any = ...
    GREENYELLOW: Any = ...
    HONEYDEW: Any = ...
    HOTPINK: Any = ...
    INDIANRED: Any = ...
    INDIGO: Any = ...
    IVORY: Any = ...
    KHAKI: Any = ...
    LAVENDER: Any = ...
    LAVENDERBLUSH: Any = ...
    LAWNGREEN: Any = ...
    LEMONCHIFFON: Any = ...
    LIGHTBLUE: Any = ...
    LIGHTCORAL: Any = ...
    LIGHTCYAN: Any = ...
    LIGHTGOLDENROD: Any = ...
    LIGHTGRAY: Any = ...
    LIGHTGREEN: Any = ...
    LIGHTPINK: Any = ...
    LIGHTSALMON: Any = ...
    LIGHTSEAGREEN: Any = ...
    LIGHTSKYBLUE: Any = ...
    LIGHTSLATEGRAY: Any = ...
    LIGHTSTEELBLUE: Any = ...
    LIGHTYELLOW: Any = ...
    LIME: Any = ...
    LIMEGREEN: Any = ...
    LINEN: Any = ...
    MAGENTA: Any = ...
    MAROON: Any = ...
    MEDIUMAQUAMARINE: Any = ...
    MEDIUMBLUE: Any = ...
    MEDIUMORCHID: Any = ...
    MEDIUMPURPLE: Any = ...
    MEDIUMSEAGREEN: Any = ...
    MEDIUMSLATEBLUE: Any = ...
    MEDIUMSPRINGGREEN: Any = ...
    MEDIUMTURQUOISE: Any = ...
    MEDIUMVIOLETRED: Any = ...
    MIDNIGHTBLUE: Any = ...
    MINTCREAM: Any = ...
    MISTYROSE: Any = ...
    MOCCASIN: Any = ...
    NAVAJOWHITE: Any = ...
    NAVYBLUE: Any = ...
    OLDLACE: Any = ...
    OLIVE: Any = ...
    OLIVEDRAB: Any = ...
    ORANGE: Any = ...
    ORANGERED: Any = ...
    ORCHID: Any = ...
    PALEGOLDENROD: Any = ...
    PALEGREEN: Any = ...
    PALETURQUOISE: Any = ...
    PALEVIOLETRED: Any = ...
    PAPAYAWHIP: Any = ...
    PEACHPUFF: Any = ...
    PERU: Any = ...
    PINK: Any = ...
    PLUM: Any = ...
    POWDERBLUE: Any = ...
    PURPLE: Any = ...
    REBECCAPURPLE: Any = ...
    RED: Any = ...
    ROSYBROWN: Any = ...
    ROYALBLUE: Any = ...
    SADDLEBROWN: Any = ...
    SALMON: Any = ...
    SANDYBROWN: Any = ...
    SEAGREEN: Any = ...
    SEASHELL: Any = ...
    SIENNA: Any = ...
    SILVER: Any = ...
    SKYBLUE: Any = ...
    SLATEBLUE: Any = ...
    SLATEGRAY: Any = ...
    SNOW: Any = ...
    SPRINGGREEN: Any = ...
    STEELBLUE: Any = ...
    TAN: Any = ...
    TEAL: Any = ...
    THISTLE: Any = ...
    TOMATO: Any = ...
    TURQUOISE: Any = ...
    VIOLET: Any = ...
    WEBGRAY: Any = ...
    WEBGREEN: Any = ...
    WEBMAROON: Any = ...
    WEBPURPLE: Any = ...
    WHEAT: Any = ...
    WHITE: Any = ...
    WHITESMOKE: Any = ...
    YELLOW: Any = ...
    YELLOWGREEN: Any = ...
    a: Any = ...
    a8: Any = ...
    b: Any = ...
    b8: Any = ...
    g: Any = ...
    g8: Any = ...
    h: Any = ...
    r: Any = ...
    r8: Any = ...
    s: Any = ...
    v: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def blend(self, Colorover) -> Color: ...
    def contrasted(self) -> Color: ...
    def darkened(self, godot_realamount) -> Color: ...
    def from_hsv(self, godot_realh, godot_reals, godot_realv, godot_reala) -> Color: ...
    def from_resource(self, *args, **kwargs) -> Any: ...
    def gray(self) -> float: ...
    def inverted(self) -> Color: ...
    def lightened(self, godot_realamount) -> Color: ...
    def linear_interpolate(self, Colorb, godot_realt) -> Color: ...
    def to_abgr32(self) -> int: ...
    def to_abgr64(self) -> int: ...
    def to_argb32(self) -> int: ...
    def to_argb64(self) -> int: ...
    def to_html(self, boolwith_alpha) -> GDString: ...
    def to_rgba32(self) -> int: ...
    def to_rgba64(self) -> int: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Dictionary:
    __pyx_vtable__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def clear(self) -> None: ...
    def duplicate(self, booldeep) -> Dictionary: ...
    def empty(self) -> bool: ...
    def erase(self, key) -> None: ...
    def get(self, key, default = ...) -> Any: ...
    def has(self, key) -> bool: ...
    def has_all(self, Arraykeys) -> bool: ...
    def hash(self) -> int: ...
    def items(self) -> Any: ...
    def keys(self) -> Array: ...
    def size(self) -> int: ...
    def to_json(self) -> GDString: ...
    def update(self, other) -> Any: ...
    def values(self) -> Array: ...
    def __contains__(self, other) -> Any: ...
    def __copy__(self) -> Any: ...
    def __deepcopy__(self) -> Any: ...
    def __delitem__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __getitem__(self, index) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __hash__(self) -> Any: ...
    def __iter__(self) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __len__(self) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setitem__(self, index, object) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class GDString:
    def __init__(self, *args, **kwargs) -> None: ...
    def begins_with(self, GDStringstring) -> bool: ...
    def bigrams(self) -> Array: ...
    def c_escape(self) -> GDString: ...
    def c_unescape(self) -> GDString: ...
    def capitalize(self) -> GDString: ...
    def dedent(self) -> GDString: ...
    def empty(self) -> bool: ...
    def ends_with(self, GDStringstring) -> bool: ...
    def erase(self, godot_intpos, godot_intchars) -> None: ...
    def find(self, GDStringwhat) -> int: ...
    def find_last(self, GDStringwhat) -> int: ...
    def findn(self, GDStringwhat) -> int: ...
    def get_base_dir(self) -> GDString: ...
    def get_basename(self) -> GDString: ...
    def get_extension(self) -> GDString: ...
    def get_file(self) -> GDString: ...
    def hash(self) -> uint32_t: ...
    def hex_to_int(self) -> int: ...
    def insert(self, godot_intat_pos, GDStringstring) -> GDString: ...
    def is_abs_path(self) -> bool: ...
    def is_rel_path(self) -> bool: ...
    def is_subsequence_of(self, GDStringstring) -> bool: ...
    def is_subsequence_ofi(self, GDStringstring) -> bool: ...
    def is_valid_float(self) -> bool: ...
    def is_valid_hex_number(self, boolwith_prefix) -> bool: ...
    def is_valid_html_color(self) -> bool: ...
    def is_valid_identifier(self) -> bool: ...
    def is_valid_integer(self) -> bool: ...
    def is_valid_ip_address(self) -> bool: ...
    def json_escape(self) -> GDString: ...
    def left(self, godot_intpos) -> GDString: ...
    def length(self) -> int: ...
    def match(self, GDStringwildcard) -> bool: ...
    def matchn(self, GDStringwildcard) -> bool: ...
    def md5_buffer(self) -> PoolByteArray: ...
    def md5_text(self) -> GDString: ...
    def pad_decimals(self, godot_intdigits) -> GDString: ...
    def pad_zeros(self, godot_intdigits) -> GDString: ...
    def percent_decode(self) -> GDString: ...
    def percent_encode(self) -> GDString: ...
    def plus_file(self, GDStringfile) -> GDString: ...
    def replace(self, GDStringkey, GDStringwith_) -> GDString: ...
    def replacen(self, GDStringkey, GDStringwith_) -> GDString: ...
    def rfind(self, GDStringwhat) -> int: ...
    def rfindn(self, GDStringwhat) -> int: ...
    def right(self, godot_intpos) -> GDString: ...
    def rsplit(self, GDStringdivisor, boolallow_empty, godot_intmaxsplit) -> PoolStringArray: ...
    def rstrip(self, GDStringchars) -> GDString: ...
    def sha256_buffer(self) -> PoolByteArray: ...
    def sha256_text(self) -> GDString: ...
    def similarity(self, GDStringstring) -> float: ...
    def split(self, GDStringsplitter) -> Array: ...
    def split_floats(self, GDStringsplitter) -> Array: ...
    def strip_edges(self, boolleft, boolright) -> GDString: ...
    def substr(self, godot_intfrom_, godot_intchars) -> GDString: ...
    def to_float(self) -> float: ...
    def to_int(self) -> int: ...
    def to_lower(self) -> GDString: ...
    def to_upper(self) -> GDString: ...
    def trim_prefix(self, GDStringprefix) -> GDString: ...
    def trim_suffix(self, GDStringsuffix) -> GDString: ...
    def xml_escape(self) -> GDString: ...
    def xml_unescape(self) -> GDString: ...
    def __add__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __hash__(self) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class NodePath:
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def destroy(self) -> None: ...
    def get_as_property_path(self) -> NodePath: ...
    def get_concatenated_subnames(self) -> GDString: ...
    def get_name(self, godot_intidx) -> GDString: ...
    def get_name_count(self) -> int: ...
    def get_subname(self, godot_intidx) -> GDString: ...
    def get_subname_count(self) -> int: ...
    def is_absolute(self) -> bool: ...
    def is_empty(self) -> bool: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Plane:
    PLANE_XY: Any = ...
    PLANE_XZ: Any = ...
    PLANE_YZ: Any = ...
    d: Any = ...
    normal: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def center(self) -> Vector3: ...
    def distance_to(self, Vector3point) -> float: ...
    def from_normal(self, *args, **kwargs) -> Any: ...
    def from_vectors(self, *args, **kwargs) -> Any: ...
    def get_any_point(self) -> Vector3: ...
    def get_d(self) -> float: ...
    def get_normal(self) -> Vector3: ...
    def has_point(self, Vector3point, godot_realepsilon) -> bool: ...
    def intersect_3(self, Planeb, Planec) -> Any: ...
    def intersects_ray(self, Vector3from_, Vector3dir) -> Any: ...
    def intersects_segment(self, Vector3begin, Vector3end) -> Any: ...
    def is_point_over(self, Vector3point) -> bool: ...
    def normalized(self) -> Plane: ...
    def project(self, Vector3point) -> Vector3: ...
    def set_d(self, godot_reald) -> None: ...
    def set_normal(self, Vector3normal) -> None: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __neg__(self) -> Any: ...
    def __pos__(self) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Quat:
    IDENTITY: Any = ...
    w: Any = ...
    x: Any = ...
    y: Any = ...
    z: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def as_string(self) -> GDString: ...
    def cubic_slerp(self, Quatb, Quatpre_a, Quatpost_b, godot_realt) -> Quat: ...
    def dot(self, Quatb) -> float: ...
    def from_axis_angle(self, *args, **kwargs) -> Any: ...
    def from_basis(self, *args, **kwargs) -> Any: ...
    def from_euler(self, *args, **kwargs) -> Any: ...
    def inverse(self) -> Quat: ...
    def is_normalized(self) -> bool: ...
    def length(self) -> float: ...
    def length_squared(self) -> float: ...
    def normalized(self) -> Quat: ...
    def set_axis_angle(self, Vector3axis, godot_realangle) -> None: ...
    def slerp(self, Quatb, godot_realt) -> Quat: ...
    def slerpni(self, Quatb, godot_realt) -> Quat: ...
    def xform(self, Vector3v) -> Vector3: ...
    def __add__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __neg__(self) -> Any: ...
    def __pos__(self) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __rsub__(self, other) -> Any: ...
    def __rtruediv__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...
    def __sub__(self, other) -> Any: ...
    def __truediv__(self, other) -> Any: ...

class RID:
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def from_resource(self, *args, **kwargs) -> Any: ...
    def get_id(self) -> int: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Rect2:
    end: Any = ...
    position: Any = ...
    size: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def abs(self) -> Rect2: ...
    def as_string(self) -> GDString: ...
    def clip(self, Rect2b) -> Rect2: ...
    def encloses(self, Rect2b) -> bool: ...
    def expand(self, Vector2to) -> Rect2: ...
    def from_pos_size(self, *args, **kwargs) -> Any: ...
    def get_area(self) -> float: ...
    def grow(self, godot_realby) -> Rect2: ...
    def grow_individual(self, godot_realleft, godot_realtop, godot_realright, godot_realbottom) -> Rect2: ...
    def grow_margin(self, godot_intmargin, godot_realby) -> Rect2: ...
    def has_no_area(self) -> bool: ...
    def has_point(self, Vector2point) -> bool: ...
    def intersects(self, Rect2b) -> bool: ...
    def merge(self, Rect2b) -> Rect2: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Transform:
    FLIP_X: Any = ...
    FLIP_Y: Any = ...
    FLIP_Z: Any = ...
    IDENTITY: Any = ...
    basis: Any = ...
    origin: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def affine_inverse(self) -> Transform: ...
    def as_string(self) -> GDString: ...
    def from_basis_origin(self, *args, **kwargs) -> Any: ...
    def from_quat(self, *args, **kwargs) -> Any: ...
    def inverse(self) -> Transform: ...
    def looking_at(self, Vector3target, Vector3up) -> Transform: ...
    def orthonormalized(self) -> Transform: ...
    def rotated(self, Vector3axis, godot_realphi) -> Transform: ...
    def scaled(self, Vector3scale) -> Transform: ...
    def translated(self, Vector3ofs) -> Transform: ...
    def xform_aabb(self, AABBv) -> AABB: ...
    def xform_inv_aabb(self, AABBv) -> AABB: ...
    def xform_inv_plane(self, Planev) -> Plane: ...
    def xform_inv_vector3(self, Vector3v) -> Vector3: ...
    def xform_plane(self, Planev) -> Plane: ...
    def xform_vector3(self, Vector3v) -> Vector3: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Transform2D:
    origin: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def affine_inverse(self) -> Transform2D: ...
    def as_string(self) -> GDString: ...
    def basis_xform(self, Vector2v) -> Vector2: ...
    def basis_xform_inv(self, Vector2v) -> Vector2: ...
    def from_rot_pos(self, *args, **kwargs) -> Any: ...
    def get_rotation(self) -> float: ...
    def get_scale(self) -> Vector2: ...
    def interpolate_with(self, Transform2Dm, godot_realc) -> Transform2D: ...
    def inverse(self) -> Transform2D: ...
    def orthonormalized(self) -> Transform2D: ...
    def rotated(self, godot_realphi) -> Transform2D: ...
    def scaled(self, Vector2scale) -> Transform2D: ...
    def translated(self, Vector2offset) -> Transform2D: ...
    def xform(self, v) -> Any: ...
    def xform_inv(self, v) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...

class Vector2:
    AXIS_X: Any = ...
    AXIS_Y: Any = ...
    DOWN: Any = ...
    INF: Any = ...
    LEFT: Any = ...
    ONE: Any = ...
    RIGHT: Any = ...
    UP: Any = ...
    ZERO: Any = ...
    height: Any = ...
    width: Any = ...
    x: Any = ...
    y: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def abs(self) -> Vector2: ...
    def angle(self) -> float: ...
    def angle_to(self, Vector2to) -> float: ...
    def angle_to_point(self, Vector2to) -> float: ...
    def as_string(self) -> GDString: ...
    def aspect(self) -> float: ...
    def bounce(self, Vector2n) -> Vector2: ...
    def clamped(self, godot_reallength) -> Vector2: ...
    def cubic_interpolate(self, Vector2b, Vector2pre_a, Vector2post_b, godot_realt) -> Vector2: ...
    def distance_squared_to(self, Vector2to) -> float: ...
    def distance_to(self, Vector2to) -> float: ...
    def dot(self, Vector2with_) -> float: ...
    def floor(self) -> Vector2: ...
    def is_normalized(self) -> bool: ...
    def length(self) -> float: ...
    def length_squared(self) -> float: ...
    def linear_interpolate(self, Vector2b, godot_realt) -> Vector2: ...
    def move_toward(self, Vector2to, godot_realdelta) -> Vector2: ...
    def normalized(self) -> Vector2: ...
    def reflect(self, Vector2n) -> Vector2: ...
    def rotated(self, godot_realphi) -> Vector2: ...
    def slide(self, Vector2n) -> Vector2: ...
    def snapped(self, Vector2by) -> Vector2: ...
    def tangent(self) -> Vector2: ...
    def __add__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __neg__(self) -> Any: ...
    def __pos__(self) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __rsub__(self, other) -> Any: ...
    def __rtruediv__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...
    def __sub__(self, other) -> Any: ...
    def __truediv__(self, other) -> Any: ...

class Vector3:
    AXIS_X: Any = ...
    AXIS_Y: Any = ...
    AXIS_Z: Any = ...
    BACK: Any = ...
    DOWN: Any = ...
    FORWARD: Any = ...
    INF: Any = ...
    LEFT: Any = ...
    ONE: Any = ...
    RIGHT: Any = ...
    UP: Any = ...
    ZERO: Any = ...
    x: Any = ...
    y: Any = ...
    z: Any = ...
    __hash__: Any = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def abs(self) -> Vector3: ...
    def angle_to(self, Vector3to) -> float: ...
    def bounce(self, Vector3n) -> Vector3: ...
    def ceil(self) -> Vector3: ...
    def cross(self, Vector3b) -> Vector3: ...
    def cubic_interpolate(self, Vector3b, Vector3pre_a, Vector3post_b, godot_realt) -> Vector3: ...
    def distance_squared_to(self, Vector3b) -> float: ...
    def distance_to(self, Vector3b) -> float: ...
    def dot(self, Vector3b) -> float: ...
    def floor(self) -> Vector3: ...
    def inverse(self) -> Vector3: ...
    def is_normalized(self) -> bool: ...
    def length(self) -> float: ...
    def length_squared(self) -> float: ...
    def linear_interpolate(self, Vector3b, godot_realt) -> Vector3: ...
    def max_axis(self) -> int: ...
    def min_axis(self) -> int: ...
    def move_toward(self, Vector3to, godot_realdelta) -> Vector3: ...
    def normalized(self) -> Vector3: ...
    def outer(self, Vector3b) -> Basis: ...
    def reflect(self, Vector3n) -> Vector3: ...
    def rotated(self, Vector3axis, godot_realphi) -> Vector3: ...
    def slide(self, Vector3n) -> Vector3: ...
    def snapped(self, Vector3by) -> Vector3: ...
    def to_diagonal_matrix(self) -> Basis: ...
    def __add__(self, other) -> Any: ...
    def __eq__(self, other) -> Any: ...
    def __ge__(self, other) -> Any: ...
    def __gt__(self, other) -> Any: ...
    def __le__(self, other) -> Any: ...
    def __lt__(self, other) -> Any: ...
    def __mul__(self, other) -> Any: ...
    def __ne__(self, other) -> Any: ...
    def __neg__(self) -> Any: ...
    def __pos__(self) -> Any: ...
    def __radd__(self, other) -> Any: ...
    def __reduce__(self) -> Any: ...
    def __rmul__(self, other) -> Any: ...
    def __rsub__(self, other) -> Any: ...
    def __rtruediv__(self, other) -> Any: ...
    def __setstate__(self, state) -> Any: ...
    def __sub__(self, other) -> Any: ...
    def __truediv__(self, other) -> Any: ...
